local fire={}
fire.effect = love.graphics.newPixelEffect[[

extern number time;
extern vec2 mouse;
extern vec2 screen;

number noise( vec3 p ) //Thx to Las^Mercury
	{
	vec3	i = floor( p );
	vec4	a = dot( i, vec3( 10, 570, 21 )) + vec4( 0, 57, 21, 78 );
	vec3	f = -0.5 * cos( (p-i)*acos(-1.)) + 0.5;
	a		  = mix( sin( a * cos(a) ),sin( (1.0 + a) * cos(1.+a) ), f.x);
	a.xy	  = mix( a.xz, a.yw, f.y );
	return mix( a.x, a.y, f.z );
	}
//-----------------------------------------------------------------------------
// Scene/Objects
//-----------------------------------------------------------------------------
number sphere(vec3 p, vec4 spr)
	{
	return length( spr.xyz - p ) - spr.w;
	}
number fire(vec3 p)
	{
	number d = sphere(p*vec3( 1.0, 0.5, 1.0 ), vec4( 0.0, -1.0, 0.0, 1.0 ) );
	return d+(noise(p+vec3(0.0,time * 2.0, 0.0))+noise(p*3.)*0.5)*0.25*(p.y) ;
	}
//-----------------------------------------------------------------------------
// Raymarching tools
//-----------------------------------------------------------------------------
number scene(vec3 p)
	{
	return min( 100. - length(p) , abs( fire(p) ) );
	}
vec4 Raymarche( vec3 org, vec3 dir )
	{
	number	d		= 0.0;
	vec3 	p		= org;
	number	glow	= 0.0;
	number	eps		= 0.02;
	bool	glowed	= false;
	for( int i = 0; i < 64; i++ )
		{
		d = scene(p) + eps;
		p += d * dir;
		if( d>eps )
			{
			if( fire(p) < .0)
				glowed = true;
			if( glowed )
       			glow = number( i ) / 64;
			}
		}
	return vec4( p, glow );
	}
//-----------------------------------------------------------------------------
// Main functions
//-----------------------------------------------------------------------------
vec4 effect( vec4 color, Image tex, vec2 tc, vec2 pc )
	{
	vec2	v		= vec2( 2.0 * pc.x - 2.0 * mouse.x, -2.7 * screen.y + 2*pc.y + 2.0*mouse.y );
	v.xy			/= screen.xy;
	vec3	org		= vec3( 0.0, -2.0, 4.0 );
	vec3	dir		= normalize(vec3( v.x * 1.6, -v.y, -1.5 ) );
	vec4	p		= Raymarche(org,dir);
	number	glow	= p.w;
	return mix( vec4(0.), mix(vec4( 1., .5,.1 ,1. ),vec4( 0.1, .5, 1., 1. ),p.y* .02 + .4), pow(glow*2.,4.));
	}
]]
return fire
